//******************************************
//           This is a C Template file
//ߣ   
//     
//
//ע
//******************************************   
#include "FlashFunction.h"
#include "MQ6822.h"




//==============================================================================
//ʽ	:FlashWriteByte 
//شֵ		:void
//		:<addr>	ָдַʹFLASHڴ(0x7E80~0x7EFF)
//          		FLASHڴרоƬ\Еro䛅ʹá
//          		¼оƬʱʹô顣ҲʹڳFLASH
//          		ڴ(0xc000~0xffff)עõַ޴룬д޸ĳṹ
//     		 <data>	дFLASHϣΪ1BYTE
//		:addrַʼд볤Ϊ1BYTEָdata
//==============================================================================
void FlashWriteByte(unsigned int addr,unsigned char data)
{	
	FLSCR1.byte = 0xa0;		
	FLSCR2.byte = 0xd5;			//enable flash command
	__asm("ld (0xf555),0xaa");
	__asm("ld (0xfaaa),0x55");
	__asm("ld (0xf555),0xa0");
	*(unsigned char* )(addr) = data;      

	FLSCR1.byte = 0x40;
	FLSCR2.byte = 0xd5;			//disable flash command
}




//==============================================================================
//ʽ	:FlashReadSequence
//شֵ		:void
//		:<addr> FLASHȡʼַ
//     		 <data> ָ꣬ʽFLASGȡϣд
//     		 <length>ʽFLASHȡĳ(BYTE)
//		:addrַʼȡFLASHָlengthϣdata
//==============================================================================
void FlashReadSequence(unsigned int addr,unsigned char* data,unsigned int length)
{
	unsigned char *p_addr = (unsigned char *)addr;
	unsigned int i;
	for(i=0;i<length;i++)
	{
		data[i] = *(p_addr+i);
		WDCDR.byte=0x4e; 		//clear wdt
	}
	
}




//==============================================================================
//ʽ	:FlashReadByte 
//شֵ		:unsigned char
//		:<addr>	FLASHȡĵַ
//		:ַָaddrȡϺش
//==============================================================================
unsigned char FlashReadByte(unsigned int addr)
{	
	return *((unsigned char *)addr);
}




//==============================================================================
//ʽ	:FlashSectionErase 
//شֵ		:void
//		:<addr> ʽַָaddrsection
//		:ַָaddr,ϵͳ˵ַԶжϡַָaddrsection(128 Bytes)
//     
//     		: addr =0x7e80 tsection:0x7e80~0x7eff 0x7e80  ϵͳ0x7e80~0x7eff  (128 Bytes)
//         		addr =0x7e99 tsection:0x7e80~0x7eff 0x7e99  ϵͳ0x7e80~0x7eff  (128 Bytes)
//         		addr =0x7eff tsection:0x7e80~0x7eff 0x7eff  ϵͳ0x7e80~0x7eff  (128 Bytes) 
//         		addr =0xf000 tsection:0xf000~0xf07f 0xf000  ϵͳ0xf000~0xf07f  (128 Bytes)
//         		addr =0xefff tsection:0xef80~0xefff 0xefff  ϵͳ0xef80~0xefff  (128 Bytes)
// 
//         section:0xXX00~0xXX7f , 0xXX80~0xXXff
// 
// 		   FLASHڴ:
//         		<section>0x7e80~0x7eff
//  	   FLASHڴ:
//         		<section>0xc000~0xc07f 
//         		<section>0xe080~0xe0ff 
//         		<section>0xe100~0xe17f 
//         		<section>0xe180~0xe1ff
//                         :
//                         :						  
//         		<section>0xff00~0xff7f 
//         		<section>0xff80~0xffff
//==============================================================================
void FlashSectionErase(unsigned int addr)
{
	FLSCR1.byte = 0xa0;		
	FLSCR2.byte = 0xd5;			//enable flash command
	__asm("ld (0xf555),0xaa");
	__asm("ld (0xfaaa),0x55");
	__asm("ld (0xf555),0x80");
	__asm("ld (0xf555),0xaa");
	__asm("ld (0xfaaa),0x55");
		
	*(unsigned char* )(addr) = 0x20;
	FLSCR1.byte = 0x40;
	FLSCR2.byte = 0xd5;			//disable flash command
	
}